# -*- coding: utf-8 -*-

"""
/***************************************************************************
 QRichDem
                                 A QGIS plugin
 Qgis wrappers for RichDem
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2022-09-22
        copyright            : (C) 2022 by Fee
        email                : freakyfee@proton.me
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = "Fee"
__date__ = "2022-09-22"
__copyright__ = "(C) 2022 by Fee"

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = "$Format:%H$"

import os
import sys
import inspect

from qgis.core import QgsApplication

# import the provider
from .gui.qgis_richdem_provider import QRichDemProvider

cmd_folder = os.path.split(inspect.getfile(inspect.currentframe()))[0]


if cmd_folder not in sys.path:
    sys.path.insert(0, cmd_folder)


class QRichDemPlugin(object):
    def __init__(self):
        self.provider = None

    def initProcessing(self):
        """Init Processing provider for QGIS >= 3.8."""
        self.provider = QRichDemProvider()
        QgsApplication.processingRegistry().addProvider(self.provider)

    def initGui(self):
        self.initProcessing()

    def unload(self):
        QgsApplication.processingRegistry().removeProvider(self.provider)
